---
layout: page
title: 开始使用Dart
permalink: /bootstrap-into-dart/
summary: 本文简单介绍了开发Flutter所需的Dart语言基础，通过该教程，您可以快速掌握Dart语言的基本特性，并用它来开发Flutter应用
keywords: Flutter使用Dart
---

<style>
dd {
    margin-bottom: 8px;
}
</style>

刚接触[Dart](https://www.dartlang.org) 语言?
我们编辑了我们最喜欢的资源，以帮助您快速学习Dart。我们查看了很多语言，并且[我们发现了Dart简单易学并且很有趣](/faq/#%E4%B8%BA%E4%BB%80%E4%B9%88flutter%E9%80%89%E6%8B%A9%E4%BD%BF%E7%94%A8dart%E8%AF%AD%E8%A8%80)。
我们希望这些资源也能使Dart学习起来更简单。

[语言概览](https://www.dartlang.org/docs/dart-up-and-running/ch02.html)
: Dart语言最好的介绍。了解Dart的功能，例如可选类型、闭包、库、词法作用域、顶层函数、命名参数、async/await等等。

[Library 总览](https://www.dartlang.org/docs/dart-up-and-running/ch03.html)
: Dart强大的核心库的概览。了解Dart对集合、异步、数字、字符串、JSON等的支持。

[专为Java开发者介绍的Dart的codelab](https://codelabs.developers.google.com/codelabs/from-java-to-dart/index.html#0">Intro to Dart for Java Developers - Codelab)
: 使用Java知识快速了解Dart并运行。通过对比Java Tutorial中的示例，了解Dart的类、构造函数、参数和接口。

[Effective Dart](https://www.dartlang.org/effective-dart/)
: 代码风格、创建文档、使用等的指南。

[Futures 教程](https://www.dartlang.org/docs/tutorials/futures/)
:学习如何使Futures，这在用Dart核心库中被广泛使用。Futures可以用来代替一次性回调

[Streams 教程](https://www.dartlang.org/docs/tutorials/streams/)
: 了解如何使用Streams，这在Dart核心库中广泛使用。Streams可以用来代替重复回调。例如，[File](https://docs.flutter.io/flutter/dart-io/File-class.html)类、使用Streams从文件中读取字节。

想要了解更多？查阅[关于Dart的书籍](https://www.dartlang.org/books/),或者在[Stack Overflow](https://stackoverflow.com/tags/dart)上提问。
